/* ----------------------------------------------------------------------------
 * Links
 */

a:link    { color: #000000; }
a:visited { color: #000000; }
a:active  { color: #b4b408; }

.notice a:link    { color: #a51924; }
.notice a:visited { color: #a51924; }
.notice a:active  { color: #ffffff; }

a.menu_link:link {
      color: #223349;
      text-decoration: none;
      font-size : 9pt;

}

a.menu_link:visited {
      color: #4f627b;
      text-decoration: none;
      font-size : 9pt;

}

a.menu_link:active {
      color: #ffffff;
      text-decoration: none;
      font-size : 9pt;
}

a.menu_link:hover {
      color: #ffffff;
      text-decoration: none;
      font-size : 9pt;
}

a.main_link:link {
      color: #465e80;
      text-decoration: none;
}

a.main_link:visited {
      color: #475e73;
      text-decoration: none;

}

a.main_link:active {
      color: #355279;
      text-decoration: none;
}

a.main_link:hover {
	  color: #d96d2b;
      text-decoration: none;
}


a.ipmi_link:link {
      color: #587691;
      text-decoration: none;
      font-size :11pt;
}

a.ipmi_link:visited {
      color: #47596a;
      text-decoration: none;
      font-size :11pt;
}

a.ipmi_link:active {
      color: #917f58;
      text-decoration: none;
      font-size :11pt;
}

a.ipmi_link:hover {
      color: #cc6600;
      text-decoration: none;
      font-size :11pt;
}


/* ----------------------------------------------------------------------------
 * Menu
 */

.menu {
      background-color: #becad5;
      min-width: 400px;
      width: 200px;
      white-space: nowrap;
}

.menu_item {
      background-image: url(big_menu_bg_c.gif); 
      background-repeat: repeat;
      background-color: #becad5;
	  font-family:Arial;
	  font-size:13pt;
	  font-weight:bold;
	  white-space: nowrap;
}

.sub_menu_item {
      font-family : Verdana, Arial, Helvetica, sans-serif;
      font-size : 8pt;
      font-weight : regular;
      padding-left: 10px;
      background-color: #becad5;
      max-width: 200px;
      overflow:hidden;
      white-space: nowrap;
}

.sub_menu_item_sel {
	  color: #becad5;
	  font-family : Verdana, Arial, Helvetica, sans-serif;
      font-size : 8pt;
      font-weight : bold;
      padding-left: 10px;
	  background-color: #d2e2f2;
	  max-width: 200px;
      overflow:hidden;
      white-space: nowrap;
}
.corner {
      font-family : Verdana, Arial, Helvetica, sans-serif;
      font-size : 8pt;
      font-weight : regular;
      background-color: #becad5;
      max-width: 200px;
      overflow:hidden;
      white-space: nowrap;

	  z-index:2; 
	  width:70;
	  padding-left:30pt;

}


/* ----------------------------------------------------------------------------
 * Dialogs
 */

.group {
      margin: 0pt 10pt 10pt 10pt;
      padding: 10pt 10pt 10pt 10pt;
      border-color: #a0b1c1;
      border-style: solid;
      border-width: 1px;
      text-align: center;
}

.groupCaption {
      color:#5477A6; 
      text-decoration : none;
      font-size : 13pt;
      font-weight : bold;
      font-family : Verdana, Arial,'Ms Sans Serif';
}

table.dialogTable {
      white-space: nowrap;
      border-width: 1px;
      text-align: left;
      vertical-align: left;
}

table.center {

}

/* ----------------------------------------------------------------------------
 * Message Boxes
 */




.noframebox {
      padding: 0.3em;
}

.framebox {
      padding: 0.3em;
      border-style: solid;
      border-color: #000000;
      border-width: 1px;
}

.nowrap { white-space: nowrap; }
.wrap { white-space: normal; }

.uppercase { text-transform:uppercase; }

.authHeading {
      color : #000000;
      text-decoration : none;
      font-size : 11pt;
      font-weight : bold;
      font-family : Arial, Helvetica, sans-serif;
}

.authLogo {
      display: none;
}

.default {
      color : #80A0E0;
      text-align: justify;
      text-decoration : none;
      font-size : 10pt;
      font-family : Arial, Helvetica, sans-serif;
}

.notice {
      color : #a51924;
      text-align: left;
      text-decoration : none;
      font-size : 8pt;
      font-family : Arial, Helvetica, sans-serif;
      width:400px;
	  padding-top:15pt;
}
.notice_nopad {
      color : #a51924;
      text-align: left;
      text-decoration : none;
      font-size : 8pt;
      font-family : Arial, Helvetica, sans-serif;
      width:400px;
}
.error {
        color: #ff0000;
	text-decoration : none;
	font-size : 11pt;
	font-weight : bold;
	font-family : Arial, Helvetica, sans-serif;
}

.tiny {
	text-decoration : none;
	font-size : 8pt;
	font-family : Arial, Helvetica, sans-serif;
}

.elem_l, .elem_r, .settings_fieldname_checkbox_en, .settings_fieldname_checkbox {
	text-decoration : none;
	font-size : 8pt;
	font-family : Arial, Helvetica, sans-serif;
	
}

.normal {
	text-decoration : none;
	font-size : 8pt;
	font-family : :Verdana,Arial, Helvetica, sans-serif;
	line-height:14pt;

}

.normal2 {
	text-decoration : none;
	font-size : 9pt;
	font-family :tahoma;
	line-height:14pt;
	color:#71813a;
	background-color: #f0f2e9;
}
.normal3 {
	text-decoration : none;
	font-size : 9pt;
	font-family :tahoma;
	line-height:14pt;
	color:#71813a;
	background-color: #ffffff;
}

.settings_fieldname,{
	text-decoration : none;
	font-size : 8pt;
	font-family : Arial, Helvetica, sans-serif;

}

.settings_field,{
	text-decoration : none;
	font-size : 8pt;
	font-family : Arial, Helvetica, sans-serif;
	background-color: #ffffff;

}

.settings_field_pad,{
	text-decoration : none;
	font-size : 8pt;
	font-family : Arial, Helvetica, sans-serif;
	background-color: #ffffff;
	padding-top:15pt;
}
.settings_padder,{
	text-decoration : none;
	font-size : 8pt;
	font-family : Arial, Helvetica, sans-serif;
	background-color: #00000;
}

.notice { 
        text-align: left; 
}

.mono { 
	font-family: monospace;
}

.table_q {
	color:#565F39; ;
	text-decoration : none;
	font-size : 8pt;
	font-weight : regular;
	font-family :Verdana, Arial, Helvetica, sans-serif;
	background-color: #F0F2E9;
	text-align: right;

}

.table_title {
	color:#71813a;
	text-decoration : none;
	font-size : 8pt;
	font-weight : regular;
	font-family :Verdana, Arial, Helvetica, sans-serif;
	background-color: #d7e4dc;
	text-align: right;
	font-weight:bold;

}
.describe  {
	color:#818181;
	font-family:Verdana, Arial, Helvetica, sans-serif;
	font-weight : regular; 
	padding-top:15pt;
	font-size:8pt;
}

.emph   { font-weight : bold; }

.elem_l , .settings_fieldname { 
	text-align: right; 
}


.settings_fieldname_checkbox_en, .settings_fieldname_checkbox {
	text-align:right;
}

.t8_green_pad_r3
{
	color:#6D860B; 
	cursor:default; 
	font-family:Verdana, Arial;
	font-size:8pt;
	Padding-right:3;
    background-color : #ffffff;
}

.elem_r,  .settings_field { text-align: left; }

.left   { text-align: left;   }
.center { text-align: center; }
.right  { text-align: right;  }

.buttons { text-align: center; }

.indent { padding-left: 16px; }

.main {
      background-color : #ffffff;
      color: #000000;
      font-size: 10pt;
      font-family: Arial, Helvetica, sans-serif;
}

.rsp_message {
	color : #000000;
	text-decoration : none;
	text-align: center;
	font-size : 11pt;
	font-weight : bold;
	font-family : Arial, Helvetica, sans-serif;
	padding : 1em 0 1em 0;
}
/* 
 * Align table in rsp_message centered (table is used for formatting bulleted
 * list centered, but the bullets horizontally lined up)  
 */
.rsp_message table {
    margin-left:auto; margin-right:auto
}


.aclcolorno      { color : #800000; }
.aclcoloryes     { color : #008000; }
.aclcolornone    { color : #800000; }
.aclcolorview    { color : #409040; }
.aclcolorcontrol { color : #008000; }

BODY {
	background-color : #ffffff;
	color : #000000;
	font-size : 10pt;
	font-family : Arial, Helvetica, sans-serif;
}

/* 
 * surrounding of the login page window 
 */
body.auth {
	background-color : #a0c0d0;
}

/*
 * table which will be maximized 
 * to the whole screen
 */
table.surroundingTable {
      height: 100%;
      width: 100%;
      text-align: center;
} 


/* 
 * title area on top of the window
 */
body.title {
      background-color : #becad5;
}

HR {
      border: 0;
      color: #000000;
      background-color: #000000;
      height: 1px;
}

P {
	color : #000000;
	font-size : 10pt;
	font-family : Arial, Helvetica, sans-serif;
}

TABLE {
	background-repeat: no-repeat
}


/*
 * table with the login form elements
 */
table.authInner {
      background-color : #ffffff;
}

.cb_field {
      width: 40px;
}

/* ----------------------------------------------------------------------------
 * Event Log
 */

.loggingTable {
      color: #000000;
      text-decoration: none;
      font-size: 10pt;
      font-family: Arial, Helvetica, sans-serif;
}

.loggingRowOdd  { background-color : #e7e7e7; }
.loggingRowEven { background-color : #ffffff; }
.loggingHeader  { background-color : #cccccc; }

/*
 * tables surrounding the form elements
 * and their cells
 */
table.pagetable {
      border-spacing : 0px;
}
table.pagetable tr td {
      background-color : #ffffff;
      padding : 5px;
}


TABLE.inner {
      background-color: #ffffff;
}

/*
 * standard table
 */
.stdtable th {padding-right: 10px;padding-left: 10px;}
.stdtable td {padding-right: 10px;padding-left: 10px;}

/* 
 * Some special definitions for colors not used in the web
 * pages but other parts of the software, to avoid using
 * a special file or other configuration method.
 * Important!
 * Leave the structure as is, just change the color, use
 * the standard 6 digit notation
 */
.specialcolor_cornerbg { color: #a0c0d0; }
.specialcolor_telnetbg { color: #ffffff; }
.specialcolor_telnetfg { color: #000000; }
.specialcolor_sshbg { color: #ffffff; }
.specialcolor_sshfg { color: #000000; }

/*-----------------------------------------------------------------------------------------------------
	Misc
-----------------------------------------------------------------------------------------------------*/

a.infobutton span { visibility:hidden; 
                    position:absolute;
                    padding:1em;
                    text-decoration:none; 
}
a.infobutton:hover span { visibility:visible;
                          border:1px solid #0076cc;
                          color:black;
                          background:white;
}


